#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <rcsc/player/player_agent.h>
#include <rcsc/action/basic_actions.h>
//#include <rcsc/action/body_go_to_point.h>
//#include <rcsc/common/server_param.h>
//#include <rcsc/player/intercept_table.h>
#include <rcsc/action/view_synch.h>
#include "bhv_matsu_chgmov.h"
//ref by view_tractical.cpp in herios-rc2007
using namespace rcsc;
bool bhv_matsu_chgmov::execute( rcsc::PlayerAgent * agent){//+1
//3.16.1 p.118

	if (! agent->world().ball().posValid() ){
		return agent->doChangeView( ViewWidth::WIDE );
	}
	const double ball_dist = agent->world().ball().distFromSelf();
	if (ball_dist > 40.0 ){
		return agent->doChangeView( ViewWidth::WIDE );
	}
	if (ball_dist > 20.0){
		return agent->doChangeView( ViewWidth::NORMAL );
	}
	if( ball_dist > 10.0 )

   {
        rcsc::AngleDeg ball_angle = agent->effector().queuedNextAngleFromBody
            ( agent->effector().queuedNextBallPos() );
        if ( ball_angle.abs() > 120.0 )
        {
            return agent->doChangeView( rcsc::ViewWidth::WIDE );
        }
    }

    //const bool teammate_kickable = agent->world().existKickableTeammate();
    //const bool opponent_kickable = agent->world().existKickableOpponent();

    double teammate_ball_dist = 1000.0;
    double opponent_ball_dist = 1000.0;

    if ( ! agent->world().teammatesFromBall().empty() )
    {
        teammate_ball_dist
            = agent->world().teammatesFromBall().front()->distFromBall();
    }

    if ( ! agent->world().opponentsFromBall().empty() )
    {
        opponent_ball_dist
            = agent->world().opponentsFromBall().front()->distFromBall();
    }

    if ( teammate_ball_dist > 5.0
         && opponent_ball_dist > 5.0
         && ball_dist > 10.0 )
    {
        return agent->doChangeView( rcsc::ViewWidth::NORMAL );
    }

    return rcsc::View_Synch().execute( agent );

}//-1
